Index: libhb/common.h
===================================================================
--- libhb/common.h	(revision 3256)
+++ libhb/common.h	(working copy)
@@ -734,6 +734,13 @@
 #endif
 };
 
+#define HB_FILTER_DETELECINE    1
+#define HB_FILTER_DEINTERLACE   2
+#define HB_FILTER_DEBLOCK       3
+#define HB_FILTER_DENOISE       4
+#define HB_FILTER_DECOMB        5
+#define HB_FILTER_ROTATE        6
+
 extern hb_filter_object_t hb_filter_detelecine;
 extern hb_filter_object_t hb_filter_deinterlace;
 extern hb_filter_object_t hb_filter_deblock;
Index: libhb/hb.c
===================================================================
--- libhb/hb.c	(revision 3256)
+++ libhb/hb.c	(working copy)
@@ -1,5 +1,9 @@
 #include "hb.h"
 #include "hbffmpeg.h"
+#include <stdio.h>
+#include <unistd.h>
+#include <io.h>
+#include <fcntl.h>
 
 #if defined( SYS_MINGW ) && defined( PTW32_STATIC_LIB )
 #include <pthread.h>
@@ -59,6 +63,7 @@
 int hb_process_initialized = 0;
 
 static void thread_func( void * );
+hb_title_t * hb_get_title_by_index( hb_handle_t *, int );
 
 void hb_avcodec_init()
 {
@@ -140,21 +145,51 @@
 }
 
 /**
- * libhb initialization routine.
- * @param verbose HB_DEBUG_NONE or HB_DEBUG_ALL.
- * @param update_check signals libhb to check for updated version from HandBrake website.
- * @return Handle to hb_handle_t for use on all subsequent calls to libhb.
+ * Ensures that the process has been initialized.
  */
-hb_handle_t * hb_init( int verbose, int update_check )
+static void process_init()
 {
     if (!hb_process_initialized)
     {
 #if defined( SYS_MINGW ) && defined( PTW32_STATIC_LIB )
         pthread_win32_process_attach_np();
 #endif
-        hb_process_initialized =1;
+
+#if defined( _WIN32 ) || defined( __MINGW32__ )
+        setvbuf( stdout, NULL, _IONBF, 0 );
+        setvbuf( stderr, NULL, _IONBF, 0 );
+#endif
+        hb_process_initialized = 1;
     }
     
+}
+
+void (*hb_log_callback)(const char* message);
+static void redirect_thread_func(void *);
+#define pipe(phandles)  _pipe (phandles, 4096, _O_BINARY)
+
+/**
+ * Registers the given function as a logger. All logs will be passed to it.
+ * @param log_cb The function to register as a logger.
+ */
+void hb_register_logger( void (*log_cb)(const char* message) )
+{
+    process_init();
+
+    hb_log_callback = log_cb;
+    hb_thread_init("ioredirect", redirect_thread_func, NULL, HB_NORMAL_PRIORITY);
+}
+
+/**
+ * libhb initialization routine.
+ * @param verbose HB_DEBUG_NONE or HB_DEBUG_ALL.
+ * @param update_check signals libhb to check for updated version from HandBrake website.
+ * @return Handle to hb_handle_t for use on all subsequent calls to libhb.
+ */
+hb_handle_t * hb_init( int verbose, int update_check )
+{
+    process_init();
+
     hb_handle_t * h = calloc( sizeof( hb_handle_t ), 1 );
     uint64_t      date;
 
@@ -478,9 +513,27 @@
 /**
  * Create preview image of desired title a index of picture.
  * @param h Handle to hb_handle_t.
+ * @param title_index Index of the title to get the preview for (1-based).
+ * @param picture Index in title.
+ * @param buffer Handle to buffer were image will be drawn.
+ */
+void hb_get_preview_by_index( hb_handle_t * h, int title_index, int picture, uint8_t * buffer )
+{
+    hb_title_t * title;
+
+    title = hb_get_title_by_index( h, title_index );
+    if ( title != NULL )
+    {
+        hb_get_preview( h, title, picture, buffer );
+    } 
+}
+
+/**
+ * Create preview image of desired title a index of picture.
+ * @param h Handle to hb_handle_t.
  * @param title Handle to hb_title_t of desired title.
  * @param picture Index in title.
- * @param buffer Handle to buufer were inage will be drawn.
+ * @param buffer Handle to buffer were image will be drawn.
  */
 void hb_get_preview( hb_handle_t * h, hb_title_t * title, int picture,
                      uint8_t * buffer )
@@ -699,11 +752,31 @@
 /**
  * Calculates job width and height for anamorphic content,
  *
+ * @param h Instance handle
+ * @param title_index Index of the title/job to inspect (1-based).
+ * @param output_width Pointer to returned storage width
+ * @param output_height Pointer to returned storage height
+ * @param output_par_width Pointer to returned pixel width
+ * @param output_par_height Pointer to returned pixel height
+ */
+void hb_set_anamorphic_size_by_index( hb_handle_t * h, int title_index,
+        int *output_width, int *output_height,
+        int *output_par_width, int *output_par_height )
+{
+    hb_title_t * title;
+    title = hb_get_title_by_index( h, title_index );
+    
+    hb_set_anamorphic_size( title->job, output_width, output_height, output_par_width, output_par_height );
+}
+
+/**
+ * Calculates job width and height for anamorphic content,
+ *
  * @param job Handle to hb_job_t
  * @param output_width Pointer to returned storage width
  * @param output_height Pointer to returned storage height
  * @param output_par_width Pointer to returned pixel width
- @ param output_par_height Pointer to returned pixel height
+ * @param output_par_height Pointer to returned pixel height
  */
 void hb_set_anamorphic_size( hb_job_t * job,
         int *output_width, int *output_height,
@@ -1019,6 +1092,53 @@
 }
 
 /**
+ * Applies information from the given job to the official job instance.
+ * @param h Handle to hb_handle_t.
+ * @param title_index Index of the title to apply the chapter name to (1-based).
+ * @param chapter The chapter to apply the name to (1-based).
+ * @param job Job information to apply.
+ */
+void hb_set_chapter_name( hb_handle_t * h, int title_index, int chapter_index, const char * chapter_name )
+{
+    hb_title_t * title;
+    title = hb_get_title_by_index( h, title_index );
+    
+    hb_chapter_t * chapter = hb_list_item( title->list_chapter, chapter_index - 1 );
+    
+    strncpy(chapter->title, chapter_name, 1023);
+    chapter->title[1023] = '\0';
+}
+
+/**
+ * Applies information from the given job to the official job instance.
+ * Currently only applies information needed for anamorphic size calculation and previews.
+ * @param h Handle to hb_handle_t.
+ * @param title_index Index of the title to apply the job information to (1-based).
+ * @param job Job information to apply.
+ */
+void hb_set_job( hb_handle_t * h, int title_index, hb_job_t * job )
+{
+	int i;
+
+    hb_title_t * title;
+    title = hb_get_title_by_index( h, title_index );
+    
+    hb_job_t * job_target = title->job;
+    
+    job_target->deinterlace = job->deinterlace;
+    job_target->width = job->width;
+    job_target->height = job->height;
+    job_target->maxWidth = job->maxWidth;
+    job_target->maxHeight = job->maxHeight;
+    for (i = 0; i < 4; i++)
+    {
+        job_target->crop[i] = job->crop[i];
+    }
+	
+    job_target->anamorphic = job->anamorphic;
+}
+
+/**
  * Adds a job to the job list.
  * @param h Handle to hb_handle_t.
  * @param job Handle to hb_job_t.
@@ -1325,6 +1445,51 @@
 }
 
 /**
+ * Gets a filter object with the given type and settings.
+ * @param filter_id The type of filter to get.
+ * @param settings The filter settings to use.
+ * @returns The requested filter object.
+ */
+hb_filter_object_t * hb_get_filter_object(int filter_id, const char * settings)
+{
+    if (filter_id == HB_FILTER_ROTATE)
+    {
+        hb_filter_rotate.settings = strdup(settings);
+        return &hb_filter_rotate;
+    }
+
+    if (filter_id == HB_FILTER_DETELECINE)
+    {
+        hb_filter_detelecine.settings = strdup(settings);
+        return &hb_filter_detelecine;
+    }
+
+    if (filter_id == HB_FILTER_DECOMB)
+    {
+        hb_filter_decomb.settings = strdup(settings);
+        return &hb_filter_decomb;
+    }
+
+    if (filter_id == HB_FILTER_DEINTERLACE)
+    {
+        hb_filter_deinterlace.settings = strdup(settings);
+        return &hb_filter_deinterlace;
+    }
+
+    if (filter_id == HB_FILTER_DEBLOCK)
+    {
+        hb_filter_deblock.settings = strdup(settings);
+        return &hb_filter_deblock;
+    }
+
+    if (filter_id == HB_FILTER_DENOISE)
+    {
+        hb_filter_denoise.settings = strdup(settings);
+        return &hb_filter_denoise;
+    }
+}
+
+/**
  * Returns the state of the conversion process.
  * @param h Handle to hb_handle_t.
  * @param s Handle to hb_state_t which to copy the state data.
@@ -1519,6 +1684,25 @@
 }
 
 /**
+ * Redirects stderr to the registered callback
+ * function.
+ * @param _data Unused.
+ */
+static void redirect_thread_func(void * _data)
+{
+    int pfd[2];
+    pipe(pfd);
+    stderr->_file = pfd[1];
+    FILE * log_f = fdopen(pfd[0], "rb");
+    
+    char line_buffer[500];
+    while(fgets(line_buffer, 500, log_f) != NULL)
+    {
+        hb_log_callback(line_buffer);
+    }
+}
+
+/**
  * Returns the PID.
  * @param h Handle to hb_handle_t
  */
@@ -1530,6 +1714,7 @@
 /**
  * Returns the id for the given instance.
  * @param h Handle to hb_handle_t
+ * @returns The ID for the given instance
  */
 int hb_get_instance_id( hb_handle_t * h )
 {
@@ -1537,6 +1722,29 @@
 }
 
 /**
+ * Returns the title with the given title index.
+ * @param h Handle to hb_handle_t
+ * @param title_index the index of the title to get
+ * @returns The requested title
+ */
+hb_title_t * hb_get_title_by_index( hb_handle_t * h, int title_index )
+{
+    hb_title_t * title;
+    int i;
+	int count = hb_list_count( h->list_title );
+    for (i = 0; i < count; i++)
+    {
+        title = hb_list_item( h->list_title, i );
+        if (title->index == title_index)
+        {
+            return title;
+        }
+    }
+    
+    return NULL;
+}
+
+/**
  * Sets the current state.
  * @param h Handle to hb_handle_t
  * @param s Handle to new hb_state_t
Index: libhb/hb.h
===================================================================
--- libhb/hb.h	(revision 3256)
+++ libhb/hb.h	(working copy)
@@ -14,6 +14,7 @@
 #define HB_DEBUG_NONE 0
 #define HB_DEBUG_ALL  1
 void          hb_register( hb_work_object_t * );
+void          hb_register_logger( void (*log_cb)(const char* message) );
 hb_handle_t * hb_init( int verbose, int update_check );
 hb_handle_t * hb_init_dl ( int verbose, int update_check ); // hb_init for use with dylib
 
@@ -43,6 +44,8 @@
                        int title_index, int preview_count,
                        int store_previews );
 void          hb_scan_stop( hb_handle_t * );
+hb_filter_object_t * hb_get_filter_object(int filter_id, const char * settings);
+uint64_t      hb_first_duration( hb_handle_t * );
 
 /* hb_get_titles()
    Returns the list of valid titles detected by the latest scan. */
@@ -53,16 +56,22 @@
    Taken from Thomas Oestreich's 32detect filter in the Transcode project.  */
 int hb_detect_comb( hb_buffer_t * buf, int width, int height, int color_equal, int color_diff, int threshold, int prog_equal, int prog_diff, int prog_threshold );
 
+void          hb_get_preview_by_index( hb_handle_t *, int, int, uint8_t * );
 void          hb_get_preview( hb_handle_t *, hb_title_t *, int,
                               uint8_t * );
 void          hb_set_size( hb_job_t *, double ratio, int pixels );
+void          hb_set_anamorphic_size_by_index( hb_handle_t *, int,
+                int *output_width, int *output_height,
+                int *output_par_width, int *output_par_height );
 void          hb_set_anamorphic_size( hb_job_t *,
                 int *output_width, int *output_height,
-                int *output_par_width, int *output_par_height);
+                int *output_par_width, int *output_par_height );
 
 /* Handling jobs */
 int           hb_count( hb_handle_t * );
 hb_job_t *    hb_job( hb_handle_t *, int );
+void          hb_set_chapter_name( hb_handle_t *, int, int, const char * );
+void          hb_set_job( hb_handle_t *, int, hb_job_t * );
 void          hb_add( hb_handle_t *, hb_job_t * );
 void          hb_rem( hb_handle_t *, hb_job_t * );
 
